/*
 *	main.c
 *
 *	SG-1000/EMU
 *
 *	* Thu Jan 6 00:00:00 JST 2005 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

//#define TEST
#ifdef TEST
void test();
#endif /*TEST*/

/****************************************************************************
 *	
 ****************************************************************************/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
#ifndef TEST
	app_main();
#else /*TEST*/
	test();
#endif /*TEST*/

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);

	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	//srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* ؑցE16K\܂B */
	ldirect_free();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */

#ifdef USE_PAUSE
		/* PAUSEB */
		if(mode) { /* G~[VŝPAUSE\ */
			if((joy & TRG_START) ||
			   (pause && (joy & TRG_SELECT))) { /* PAUSESELECTňCEmulationI */
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
					pceWaveSetChAtt(0, 127); /* SOUND OFF */
				} else {	/* PAUSE OUT */
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
					pceWaveSetChAtt(0, 0); /* SOUND ON */
				}
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 15);
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	file_init
 ****************************************************************************/

static int file_item_compare(const void* _a, const void* _b) {
	FILEITEM* a = (FILEITEM*)_a;
	FILEITEM* b = (FILEITEM*)_b;
	return strcmp(a->fname, b->fname);
}

static void file_sort() {
	qsort(file_list, file_num, sizeof(FILEITEM), file_item_compare);
}

void
file_init()
{
	int len;
	FILEINFO fi;
	FILEITEM* item;

	/* vbuff[256x192]̂128x88ȍ~̓t@CIɂ͎gȂ̂ŁA
	 * t@CXg̈Ƃėp܂B
	 * G~[Vsƃt@CXg̈悪j󂳂̂ŁA
	 * t@CXgč쐬Kv܂B
	 */
	if((128 * 88) + (sizeof(FILEITEM) * MAX_FILE) > sizeof vbuff) {
		DIE();
	}
	file_list = (FILEITEM*)(vbuff + 128 * 88);
	memset(file_list, 0, sizeof(FILEITEM) * MAX_FILE);

	file_num = 0;
	item = file_list;
	pceFileFindOpen(&fi);
	while(file_num < MAX_FILE) {
		if(!pceFileFindNext(&fi)) {
			break;
		}

		len = strlen(fi.filename);
		if((len < 1 + 2) || (len > MAXFILENAME)) {
			continue;
		}
		if(strcasecmp(&fi.filename[len - (1 + 2)], ".sg") != 0) {
			continue;
		}

		strcpy(item->fname, fi.filename);
		item->size = fi.length;

		file_num++;
		item++;
	}
	pceFileFindClose(&fi);

	/* t@CXgt@C̏ɕёւ܂B
	 * X^bNeʂƂȂ̂ŁAʃobt@g܂B
	 * 128x88=11KB΂܂vł傤B
	 */
	stack_switch(vbuff + 128 * 88, file_sort, 0, 0);
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	int retval;
	int c;
	int i;
	int y;
	int i_file;
	FILEITEM* item;

RESET:
	/* t@CXg쐬B */
	file_init();
	if(!file_num) {
		err_disp("ROM̧(*.sg)܂");
		exit(0);
	}

	for(;;) {
		schedule();

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(joy & TRG_UP) cursel--;
		if(joy & TRG_DN) cursel++;
		if(joy & TRG_LF) cursel -= MAX_DISP;
		if(joy & TRG_RI) cursel += MAX_DISP;
		if(cursel < 0                      ) cursel = 0;
		if(cursel > file_num - 1           ) cursel = file_num - 1;
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* G~[VJnH */
		if(joy & TRG_AB) {
			item = &file_list[cursel];
			mode = 1; /* G~[Vs */
			retval = sg1000_run(item->fname, joy & TRG_A ? 1/*SoundOn*/ : 0/*SoundOff*/);
			mode = 0; /* t@CI */
			if(retval == 0) {
				goto RESET; /* t@CXgč쐬K{!! */
			} else {
				err_disp("sł܂ł");
			}
		}

		/* t@CXg\B */
		surface_clear(&surface, 0);
		item = &file_list[curtop];
		y = 8;
		for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
			i_file = curtop + i;
			if(i_file > file_num - 1) break;
			if(i_file == cursel) {
				render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 10);
				c = 0;
			} else {
				c = 10;
			}
			render_string(&render, 4 + 4 *  1, y, item->fname, 0x82, c);
			render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", item->size);
			item++;
			y += 6;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 15);
		render_string(&render, 0, 1,
		//       012345678901234567890123456789012
			"========== SG-1000/EMU ==========",
			0x82, 0);
	}
}

/****************************************************************************
 *	test
 ****************************************************************************/

//__SIZEOF_FRAM_ADDR            $$lk33$$              uscn     global   00000c68	(C)
// N=100	117	(C)

#ifdef TEST
void
test()
{
	int i;
	int t0;
	int t1;

	for(i = 0; i < 10; i++) {
		schedule();
	}

	for(i = 0; i < sizeof sg1000_dcsg; i++) {
		((unsigned char*)&sg1000_dcsg)[i] = (unsigned char)(i ^ 0x77);
	}

	tms9918_reset(&sg1000_vdp);
	//
	tms9918_write(&sg1000_vdp, 1, 0x02);
	tms9918_write(&sg1000_vdp, 1, 0x80);
	tms9918_write(&sg1000_vdp, 1, 0x42);
	tms9918_write(&sg1000_vdp, 1, 0x81);
	tms9918_write(&sg1000_vdp, 1, 0x00);
	tms9918_write(&sg1000_vdp, 1, 0x40);
	for(i = 0; i < 0x4000; i++) {
		tms9918_write(&sg1000_vdp, 0, rand());
	}

DISABLE;
	t0 = pceTimerGetCount();
	for(i = 0; i < 100; i++) {
		tms9918_update(&sg1000_vdp, vbuff);
	}
	t1 = pceTimerGetCount();
ENABLE;

	for(i = 0; i < sizeof sg1000_dcsg; i++) {
		if(((unsigned char*)&sg1000_dcsg)[i] != (unsigned char)(i ^ 0x77)) {
			DIE();
		}
	}

	tms9918_reduce(vbuff, vbuff);
	render_printf_framed(&render, 64, 44, 0x80, 0xff0, "%d", t1 - t0);
	for(;;) {
		schedule();
	}
}
#endif /*TEST*/
